SystemOrganization addCategory: #'Sheet-PureExample'!

WAApplication subclass: #ShExampleExcelSheet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-PureExample'!

!ShExampleExcelSheet class methodsFor: 'as yet unclassified' stamp: 'topa 2/3/2014 23:21'!
applicationName

	^ 'pureexample.xml'! !

!ShExampleExcelSheet class methodsFor: 'as yet unclassified' stamp: 'topa 2/3/2014 23:21'!
register
	"self register"
	
	| application |
	application := WAAdmin
		register: self
		at: self applicationName.
! !

!ShExampleExcelSheet class methodsFor: 'as yet unclassified' stamp: 'topa 2/3/2014 23:22'!
unregister
	"self unregister"
	
	WAAdmin unregister: self applicationName.! !

!ShExampleExcelSheet methodsFor: 'as yet unclassified' stamp: 'topa 2/3/2014 23:22'!
handleFiltered: aRequestContext

	aRequestContext respond: [:response |
		response
			doNotCache;
			attachmentWithFileName: self class applicationName;	
			contentType: (WAMimeType main: 'application' sub: 'xml');
			nextPutAll: (
				((WABuilder on: ShSpreadsheetCanvas)
					rootClass: ShSpreadsheetRoot;
					documentClass: WAXmlDocument;
					yourself)
						fullDocument: true;
			rootBlock: [ :root | " nothing, or what you want... " ];
			render: [ :sheet | "this is a spreadsheet canvas"
							sheet workbook with: [
								sheet documentProperties: [
			sheet 
										author: 'esteban';
										created: (String streamContents: [:stream | |now|
											now := DateAndTime now.
											GRPrinter isoDate print: now on: stream.
											stream nextPut: $T.
											GRPrinter isoTime print: now on: stream.
											stream nextPut: $Z]);
										version: '12.00'].
								sheet excelWorkbook: [
									(sheet tag: 'WindowHeight') with: '6795'.
									(sheet tag: 'WindowWidth') with: '8460'.
									(sheet tag: 'WindowTopX') with: '120'.
									(sheet tag: 'WindowTopY') with: '15'.
									(sheet tag: 'NoAutorRecover').
									(sheet tag: 'ProtectStructure') with: 'False'.
									(sheet tag: 'ProtectWindows') with: 'False'].
								sheet styles: [ "do whatever style you need here" ].
								sheet worksheet
									name: 'sheet 1';
									with: [
										sheet table
											fullColumns: 1;
											fullRows: 1;	 
											expandedRowCount: 42;
											expandedColumnCount: 34;		
											with: [ "example data." | heads |
													heads := #( 'Title' 'First Name' 'Last Name' 'Email' 'Homepage' 'Phone').
													heads do: [:header | sheet column caption: header; style: #header].
													sheet row: [
														heads do: [:header |
															sheet cell
																style: #header;
																with: [sheet data: [sheet text: header greaseString]]]].
												 #(
													#( 'Mr.' 'James' 'Bond' '007@mi5.gov.uk' 'bond.mi5.gov.uk' '0044 12345 007' )
													#( 'Herr' 'Ernst Stavro' 'Blofeld' 'herrblo@spectreboese.de' 'herrbloboese.de' '0049 30 1234567' )
													#( 'Dr.' 'Julius' 'No' 'juluno@edel.de' nil '0049 30 987654321' )
													#( nil 'Francisco' 'Scaramanga' 'franci@scara.it' nil '0039 12 3456 781')
												) do: [:dataLine | 
													sheet row: [ 
														dataLine do: [:datum |	
															sheet cell
																style: #default;
																with: [
																	datum ifNotNil: [
																		sheet data
																			with: [sheet text: datum greaseString]]]]]]]]]]
	)]! !
